<?php
/*  Copyright 2002-2003 Patrick R. Michaud (pmichaud@pobox.com)
    This file is part of PmWiki; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License
    (at your option) any later version.  See pmwiki.php for full details.

    This script enables markup of the form <<|TrailPage|>> to be 
    used to build "trails" through wiki documents.
    To enable this feature, just execute
   	include_once("scripts/trails.php");
    from local.php somewhere.
    Once enabled, the <<|TrailPage|>> markup is replaced with
    << PrevPage | TrailPage | NextPage >> on output.  TrailPage should
    contain either a bullet or number list defining the sequence of pages
    in the "trail".
*/

$TrailLinkPattern = 
  "(?:($GroupNamePattern)([\\/.]))?(($WikiWordPattern)|($FreeLinkPattern))";
$DoubleBrackets["/&lt;&lt;\\|($TrailLinkPattern)\\|&gt;&gt;/e"] 
  = 'MakeTrail("$1");';

function MakeTrail($link) {
  global $pagename,$Newline,$TrailLinkPattern;
  $trailname = FmtWikiLink('',$link,NULL,'PageName');
  $trailpage = ReadPage($trailname);
  if ($trailpage) {
    $trailgroup = FmtPageName('$Group',$trailname);
    foreach(explode($Newline,$trailpage['text']) as $x) {
      if (preg_match("/^[#*]+\\s*($TrailLinkPattern)/",$x,$match)) 
        $tlinks[] = ($match[2]>'') ? $match[1] : $trailgroup.'/'.$match[1];
    }
    for($i=0;$i<count($tlinks);$i++) {
      $tname = FmtWikiLink('',$tlinks[$i],NULL,'PageName',$trailpage);
      if ($tname == $pagename) {
        if ($i>0) $prev = $tlinks[$i-1];
        if ($i+1<count($tlinks)) $next = $tlinks[$i+1];
      }
    }
  }
  return "&lt;&lt; $prev | $link | $next &gt;&gt;";
}
    
?>
